/* FILE: xpfloat.cc                    -*-Mode: c++-*-
 *
 * Class for extended floating point precision using
 * compensated summation.
 * 
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 1999/09/21 21:32:02 $
 * Last modified by: $Author: donahue $
 */

#include "xpfloat.h"

/* End includes */     

void Nb_Xpfloat::Accum(REALWIDE y)
{
  REALWIDE sum1,sum2;
  // Calculate sum
  sum1=y+corr;
  sum2=x+sum1;

  // Determine new correction term
  corr= (x-sum2)+sum1;

  x=sum2;  // New sum
}

void Nb_Xpfloat::Accum(const Nb_Xpfloat &y)
{
  if((x>0 && y.x>0) || (x<0 && y.x<0)) {
    Accum(y.corr);  Accum(y.x);
  } else {
    Accum(y.x);  Accum(y.corr);
  }
}
